+++
date = '2019-09-13'
title = 'Hackathon Code4Blind'
tags = ["hackathon", "android", "java"]
+++

Code4Blind was a **hackathon** organized by _[Les désordinateurs communicants](https://lesdesordinateurs.org)_ for working on solutions to **help visually impaired people to practice rock climbing**.

The **topics** were:
- Image processing for detecting and classifying holds
- Communicate the path and holds layout on the floor before climbing
- Recording the movements executed by a climber in order to be able to give instructions to the next climber.
- Communicate the holds around the climber while climbing

I worked on the last topic, and we decided to **experiment with binaural (positional) audio** to signal available holds around the climber.

- Hold direction is communicated with binaural audio position
- Hold distance is communicated by volume
- Sounds type (bell, drum, ...) indicate the shape of the hold
- Multiple holds can be differentiated with sound pitch

In order to start working on a prototype, we assumed we were already provided with the head position of the climber in real time, and the holds position in the path.

<!--more-->

### Results

The results were not very promising. Current **binaural audio libraries gives very inaccurate results**, especially for locating up vs down and front vs behind directions. This could be either caused by:
- The **missing head-related transfer function** (HRTF), which is different for every person and difficult to obtain without very specific equipment.
- **Inaccurate software audio processing**. Even with the best conditions, libraries never yields results that are as good as a real-world recording.
- **Lack of experience or ear training** with software-based binaural audio.

Nevertheless, the hackathon was very exciting and I really appreciated the experience, as I am both a software developer and an experienced rock climber.


### Skills
- Android dev.
- Binaural / positional audio
- Brainstorming and feedback gathering with users

### More
- [Hackathon website (french)](https://lesdesordinateurs.org/index.php/code4climb/)
- [PoC source code](https://framagit.org/lesdesordinateurs/audioxyz)
