+++
date = '2018-01-11'
title = 'PC fan controller'
tags = ["arduino", "C++", "hardware"]
+++

{{< cinema path="/images/posts/fan-controller-*.*" >}}

I came up with this because my PC has a home-made watercooling system and its motherboard does not have any external sensor pins for the water temperature sensor.

<!--more-->

So I had 3 choices for controlling the fan speeds:
1. Always keep fans at around 70% so the water never gets too hot. Effective but too noisy for my taste...
2. Control fan speed using the SSD temperature sensor (the SSD does not heat up very much, and is placed next to a watercooling radiator, so we can deduce very approximately the water temperature with it). It would require to write a custom multi-platform tool that would somehow find a way to control fan speed (and would require some reverse engineering on the motherboard).
3. Find or build an external fan controller, which uses the water temperature sensor.

I went for solution 3. and designed a small board around an __Arduino nano__, that can take __multiple temperature inputs__ from external sensors (Water and Air), and __adjust fan speed__ accordingly using a simple __temperature/speed curve__. I also put a small __OLED screen__ (_SSD1306_) to display all this information, a button to force high / low / auto fan speeds, and an __alarm__ if the temperature reaches critical values (or the sensor is disconnected / short circuited).

Since then I can barely hear my PC, even during intensive tasks :)


### Skills
- PCB design
- Basic electronics
- C++ programming on Arduino

### More
- Source code and PCB design: https://github.com/CromFr/fan-controller

<div style="display: none">
DIY soldering embedded systems
</div>
