+++
date = '2020-10-01'
title = 'Git Shard'
tags = ["linux", "git", "bash"]
+++

Git-shard is a **git extension** designed to help publish multiple small repositories (shards) from one single git private repository.

It was originally designed for [Skywing](https://github.com/SkywingvL), who contributes a lot to the _Neverwinter Nights 2_ community and has troubles releasing his work due to some parts of it being under a non-disclosure agreement.

<!--more-->

### Tech

Git shard has been written in one **single bash file**, as bash is almost always installed alongside git (even for a Windows install).

The shards are versioned inside a separate directory, and tracks the current files present in the big repository. **Shards can be manipulated exactly like standard git repositories**, using `git shard exec shard_name command` (which internally translates into `git --git-dir=.git/shards/shard_name --work-tree=shard_name command`).

Commits from the main repository can be quickly copied to each shard with a single command: `git shard commit`. This makes it **easier to use than git submodules when one change may affect multiple shards** or when there are a lot of shards.

### Skills
- Advanced bash scripting
- Git plugin / extension dev.

### More
- Source code: https://github.com/CromFr/git-shard
