+++
date = '2011-12-01'
title = 'MatrixRun game'
tags = ["gamedev", "3D", "C++"]
+++


In 2011, I worked on a 3D video game project, controlled by wiimotes, and detecting the player position with IR diodes.

It has been inspired by [WiiDesktopVR from Johnny Chung Lee](http://johnnylee.net/projects/wii/). The goal of this project was to discover the possibilities offered by the wiimotes and this 3D simulation and to make a game with it.

Johnny Chung Lee project:
<div class="cinema center">
    <a href="https://www.youtube.com/watch?v=Jd3-eiid-Uw"><img src="/images/lowres/matrixrun-wiidesktopvr.jpg"/></a>
</div>


The game goal is to progress with a ship in a tunnel, avoiding obstacles and killing enemies

The ship movements are controlled by the head of the layer, and the guns by two wiimotes held by the player.



In-game video : Random tunnel generation, player movements and fire
<div class="cinema center">
	<video controls>
		<source src="/media/matrixrun.webm" type="video/webm"/>
		<source src="/media/matrixrun.mp4" type="video/mp4"/>
		<a href="/media/matrixrun.mp4">Download video</a>
	</video>
</div>

### Skills

- Rigor in code writing, object-oriented model design
- 3D engine use : Irrlicht
- Common interface driven input/output
- Random tunnel generation, by defining each polygon
- Particle system (for visual effects like explosion and smoke) : Spark Particle Engine
- Game presentation in ISEN open days, and in some local events

### More

- Source code: https://github.com/CromFr/MatrixRun
