+++
date = '2016-01-01'
title = 'STNeverwinterScript'
tags = ["nwn2", "sublime-text", "plugin", "python"]
+++

{{< cinema path="/images/posts/stneverwinterscript-*.*" >}}

STNeverwinterScript provides a lot of **IDE-like features** to Sublime Text 3 **for writing NeverwinterScript** code.

NeverwinterScript is a C-like language, with enough differences that **standard tools provide inaccurate results** or simply don't work. STNeverwinterScript provides a replacement for those tools, integrated into the editor.

It features:
- **Syntax highlighting**
- **Auto-completion** for functions, constants, #define and #include scripts names
- **Documentation** pop-ups generated from in-line documentation
- **Code snippets**
- Basic build tool (run the compiler against the current file / folder)
- **Smart build tool** (quick multi-threaded compilation)
- 2DA syntax hilighting (2D-arrays)

<!--more-->

### Tech

Completions are generated using **regex-based parsing** (it's not perfect but it is a lot simpler than implementing a fully featured language lexer), and updates the symbol list in real time (unmodified files are cached).

The smart build tool keep a list of all scripts, **creating and updating a dependency tree**. If a file is modified, all scripts that depends on it are queued for compilation. The scripts to compile are then **spread across multiple compiler processes** (the compiler is single threaded) for faster compilation.

### Skills
- Python 3
- Language-specific IDE features: auto completion, documentation, build system, ..
- Software optimization (caching, multi-threading)
- Multi-platform support (mostly case sensitivity handling)

### More
- [Package statistics](https://packagecontrol.io/packages/Neverwinter%20Script%20syntax%20and%20build)
- Source code: https://github.com/CromFr/STNeverwinterScript
