+++
date = '2014-05-01'
title = 'Tempest Autonomous sailboat'
tags = ["hardware", "dlang", "embedded", "school project"]
+++

{{< cinema path="/images/posts/microtransat-*.*" >}}

My 4th year project at ISEN Brest was the development of an __autonomous sailboat__, in order to participate in the Microtransat in few years.


### Microtransat

The Microtransat Challenge is a transatlantic race of fully autonomous sailing boats, measuring less than 4 meters.

This race was created in 2006 and no one has ever succeeded, with 7 trials from university and engineering school teams.

The goal of ISEN Brest is to participate and win this race in 1 or 2 years.

<!--more-->

### Our work

We (_Thomas Abot_ and I) were charged to work mainly on the software part: receiving processed sensor values to make some decisions, and send command values to the servo-motors. However we ended up working on the full stack from hardware choice, interfacing, data processing to the boat intelligence and networking.

The boats embeds a _Beaglebone Black_ card (similar to the Raspberry Pi, but more hardware-oriented). We also designed the electronic add-on for the Beaglebone to connect the different sensors and actuators.

This project had many challenging (understand interesting) parts:
- Design a socket interface so the hardware acquisition can be developed independently from the intelligence.
- Provide a modular simulation web interface to test and debug the program as much as possible.
- Wind optimization: the boat goes faster windward than downwind.
- Tacking: The boat cannot go directly upwind, and the program needs to handle this correctly.
- Fixing the kernel PWM drivers that had a bug preventing to generate more than 2 PWM.
- Find solutions for:
	+ Cable jamming around the servo-motors.
	+ Van design, placement and electronics.

### Skills

- Interface sensors and actuators with the program
- Defining sail boat intelligence
- D Language
- Cross-compiling D code using GCC/GDC
- Inter-process communication


### More
- [Source code](https://github.com/ISEN-TempestProject)
- [Presentation slides (fr)](https://tcharles.fr/slides/voilierautonome-pres/index.html)
- [Report (fr)](/res/tempest.pdf)

<div style="display: none">
embedded systems linux beaglebone electronics sensor data acquisition
</div>
